﻿using BPA.SAAS.Manage.Application.DataBase.Dtos.GoodsTechnology;
using BPA.SAAS.Manage.Application.DataBase.Interface;
using BPA.SAAS.Manage.Comm.Const;
using BPA.SAAS.Manage.Core.Base;
using BPA.SAAS.Manage.Core.DataBase;
using BPA.SAAS.Manage.Core.Device;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPA.SAAS.Manage.Application.DataBase.Services
{
    public class GoodsTechnologyService: IGoodsTechnologyService, ITransient
    {
        ISqlSugarClient _db;
        public GoodsTechnologyService(ISqlSugarClient db)
        {
            _db = db;
        }
      
        //#region 配方工艺流程
        ///// <summary>
        ///// 获取工艺流程
        ///// </summary>
        ///// <param name="inputDto"></param>
        ///// <returns></returns>
        //public PageUtil GetBomTechnologyPage(PageInputBase inputDto)
        //{
        //    int total = new RefAsync<int>();
        //    var res = _db.Queryable<BPA_BomTechnology, BPA_BOMEntry, BPA_Batching>((a, b, c) => new
        //    JoinQueryInfos(JoinType.Left, a.BomentryId == b.Id, JoinType.Left, b.BatchingId == c.Id)
        //   ).Where((a, b, c) => a.IsDeleted == 0 && a.ChnologyId == inputDto.chnologyId && a.GroupId == groupId)
        //   .WhereIF(!string.IsNullOrWhiteSpace(inputDto.bomId), (a, b, c) => b.BomId == inputDto.bomId)
        //    .OrderBy(a => a.Sort, OrderByType.Asc)
        //   .Select((a, b, c) => new
        //   {
        //       Id = a.Id,
        //       BatchingId = a.BomentryId,
        //       ChnologyId = a.ChnologyId,
        //       BatchingName = c.Batching_Name,
        //       BomQty = b.BomQty,
        //       TotalCount = a.TotalCount,
        //       Sort = a.Sort
        //   }).ToPageList(inputDto.Current, inputDto.PageSize, ref total);
        //    return new PageUtil()
        //    {
        //        Data = res,
        //        Total = total
        //    };
        //}
        ///// <summary>
        ///// 添加工艺流程
        ///// </summary>
        ///// <param name="inputDto"></param>
        ///// <returns></returns>
        //public async Task<bool> AddBomTechnology(List<BomTechnologyBaseDto> inputDto)
        //{
        //    var groupId = string.IsNullOrWhiteSpace(CurrentUser.TenantId)
        //        ? App.User?.FindFirst(ClaimConst.GroupId)?.Value
        //        : CurrentUser.TenantId;
        //    var res = 0;
        //    var addlist = new List<BPA_BomTechnology>();
        //    var uplist = new List<BPA_BomTechnology>();
        //    var list = _db.Queryable<BPA_BomTechnology>().Where(x => x.GroupId == groupId && x.IsDeleted == 0).ToList();
        //    for (int i = 0; i < inputDto.Count; i++)
        //    {
        //        if (list.Count > 0)
        //        {
        //            var model = list.Where(a => a.BomentryId == inputDto[i].BatchingId && a.IsDeleted == 0 && a.ChnologyId == inputDto[i].ChnologyId).FirstOrDefault();
        //            if (model != null)
        //            {
        //                model.BomentryId = inputDto[i].BatchingId;
        //                model.Sort = inputDto[i].Sort;
        //                model.TotalCount = inputDto[i].total;
        //                uplist.Add(model);
        //            }
        //            else
        //            {
        //                var data = new BPA_BomTechnology()
        //                {
        //                    Id = Guid.NewGuid().ToString(),
        //                    BomentryId = inputDto[i].BatchingId,
        //                    ChnologyId = inputDto[i].ChnologyId,
        //                    Sort = inputDto[i].Sort,
        //                    CreateAt = DateTime.Now,
        //                    GroupId = groupId,
        //                    IsDeleted = 0,
        //                    TotalCount = inputDto[i].total
        //                };
        //                addlist.Add(data);
        //            }
        //        }
        //        else
        //        {
        //            var data = new BPA_BomTechnology()
        //            {
        //                Id = Guid.NewGuid().ToString(),
        //                BomentryId = inputDto[i].BatchingId,
        //                ChnologyId = inputDto[i].ChnologyId,
        //                Sort = inputDto[i].Sort,
        //                CreateAt = DateTime.Now,
        //                GroupId = groupId,
        //                IsDeleted = 0,
        //            };
        //            addlist.Add(data);
        //        }
        //    }
        //    if (addlist.Count > 0)
        //    {
        //        res = await _db.Insertable(addlist).ExecuteCommandAsync();
        //    }
        //    if (uplist.Count > 0)
        //    {
        //        res = await _db.Updateable(uplist).ExecuteCommandAsync();
        //    }

        //    return res > 0;
        //}
        ///// <summary>
        ///// 修改工艺流程
        ///// </summary>
        ///// <param name="inputDto"></param>
        ///// <returns></returns>
        //public bool UpdateBomTechnology(BomTechnologyBaseDto inputDto)
        //{
        //    var check = _db.Queryable<BPA_BomTechnology>().Any(a => a.BomentryId == inputDto.BatchingId && a.IsDeleted == 0 && a.ChnologyId == inputDto.ChnologyId && a.Id != inputDto.Id);
        //    if (check) throw Oops.Oh("工艺流程已存在");
        //    var data = _db.Queryable<BPA_BomTechnology>().Where(a => a.Id == inputDto.Id).First();
        //    if (data == null) throw Oops.Oh("工艺流程不存在");
        //    data.BomentryId = inputDto.BatchingId;
        //    data.ChnologyId = inputDto.ChnologyId;
        //    data.Sort = inputDto.Sort;
        //    var res = _db.Updateable(data).ExecuteCommand();
        //    return res > 0;
        //}
        ///// <summary>
        ///// 删除工艺流程
        ///// </summary>
        ///// <param name="ids"></param>
        ///// <returns></returns>
        //public bool DeleteBomTechnology(List<string> ids)
        //{
        //    var resEntity = _db.Queryable<BPA_BomTechnology>().Where(x => ids.Contains(x.Id)).ToList();
        //    foreach (var item in resEntity)
        //    {
        //        item.IsDeleted = 1;
        //    }
        //    var res = _db.Updateable(resEntity).ExecuteCommand();
        //    return res > 0;
        //}
        //#endregion
        //#region 配方工艺动作
        ///// <summary>
        ///// 查询配方工艺流程动作
        ///// </summary>
        ///// <returns></returns>
        //public BPA_BomTechnologyAction GetBomTechnologyAction(BomTechnologyActionBase dto)
        //{
        //    var res = _db.Queryable<BPA_BomTechnologyAction>().Where(x => x.IsDeleted == 0 && x.BomId == dto.BomId && x.ChnologyId == dto.ChnologyId && x.GroupId == groupId)
        //    .OrderBy(i => i.Sort, OrderByType.Desc)
        //     .First();
        //    return res;
        //}
        //public async Task<List<BPA_BomTechnologyAction>> GetBomTechnologyActionList(string BomId)
        //{
        //    var res = await _db.Queryable<BPA_BomTechnologyAction>().Where(x => x.IsDeleted == 0 && x.BomId == BomId && x.GroupId == groupId)
        //    .OrderBy(i => i.Sort, OrderByType.Asc)
        //     .ToListAsync();
        //    return res;
        //}
        //public BPA_BomTechnologyAction GetBomTechnologyActionById(string id)
        //{
        //    var res = _db.Queryable<BPA_BomTechnologyAction>().Where(x => x.Id == id)
        //    .OrderBy(i => i.Sort, OrderByType.Desc)
        //     .First();
        //    return res;
        //}

        ///// <summary>
        ///// 添加配方工艺流程动作步骤
        ///// </summary>
        ///// <param name="inputDto"></param>
        ///// <returns></returns>
        //public async Task<bool> AddBomTechnologyAction(BomTechnologyActionBaseDto inputDto)
        //{
        //    var res = 0;
        //    var addlist = new BPA_BomTechnologyAction();
        //    var uplist = new BPA_BomTechnologyAction();
        //    var list = _db.Queryable<BPA_BomTechnologyAction>().Where(x => x.GroupId == groupId && x.IsDeleted == 0).ToList();

        //    if (inputDto != null)
        //    {

        //        if (list.Count > 0)
        //        {
        //            var sort = list.Max(x => x.Sort);
        //            var model = list.Where(a => a.BomId == inputDto.BomId && a.IsDeleted == 0 && a.ChnologyId == inputDto.ChnologyId && a.BomId == inputDto.BomId).FirstOrDefault();
        //            if (string.IsNullOrEmpty(inputDto.Id))
        //            {
        //                model = null;
        //            }
        //            if (model != null)
        //            {
        //                model.ActionJson = inputDto.ActionJson;
        //                model.StepName = inputDto.StepName;
        //                uplist = model;
        //            }
        //            else
        //            {
        //                var data = new BPA_BomTechnologyAction()
        //                {
        //                    Id = Guid.NewGuid().ToString(),
        //                    ActionJson = inputDto.ActionJson,
        //                    ChnologyId = inputDto.ChnologyId,
        //                    StepName = inputDto.StepName,
        //                    CreateAt = DateTime.Now,
        //                    GroupId = groupId,
        //                    IsDeleted = 0,
        //                    BomId = inputDto.BomId,
        //                    Sort = sort + 1,
        //                    IsBatch = inputDto.IsBatch
        //                };
        //                addlist = data;
        //            }
        //        }
        //        else
        //        {
        //            var data = new BPA_BomTechnologyAction()
        //            {
        //                Id = Guid.NewGuid().ToString(),
        //                ActionJson = inputDto.ActionJson,
        //                StepName = inputDto.StepName,
        //                ChnologyId = inputDto.ChnologyId,
        //                CreateAt = DateTime.Now,
        //                GroupId = groupId,
        //                IsDeleted = 0,
        //                BomId = inputDto.BomId,
        //                Sort = 1,
        //                IsBatch = inputDto.IsBatch
        //            };
        //            addlist = data;
        //        }
        //    }
        //    if (!string.IsNullOrWhiteSpace(addlist.ActionJson))
        //    {
        //        res = await _db.Insertable(addlist).ExecuteCommandAsync();
        //    }
        //    if (!string.IsNullOrWhiteSpace(uplist.ActionJson))
        //    {
        //        res = await _db.Updateable(uplist).ExecuteCommandAsync();

        //    }
        //    return res > 0;
        //}

        ///// <summary>
        ///// 删除工艺动作步骤
        ///// </summary>
        ///// <param name="ids"></param>
        ///// <returns></returns>
        //public async Task<bool> DeleteBomTechnologyAction(string ids)
        //{
        //    var resEntity = _db.Queryable<BPA_BomTechnologyAction>().Where(x => ids == x.Id).First();
        //    if (resEntity == null) throw Oops.Oh("工艺流程不存在");
        //    if (resEntity.IsBatch)
        //    {
        //        //如果是绑定的是物料的步骤 则删除物料步骤相关表数据
        //        var resEntitywl = _db.Queryable<BPA_BomTechnology>().Where(x => resEntity.ChnologyId.Contains(x.ChnologyId) && x.GroupId == groupId).ToList();
        //        foreach (var item in resEntitywl)
        //        {
        //            item.IsDeleted = 1;
        //        }
        //        await _db.Updateable(resEntitywl).ExecuteCommandAsync();
        //    }
        //    resEntity.IsDeleted = 1;
        //    var res = await _db.Updateable(resEntity).ExecuteCommandAsync();
        //    return res > 0;
        //}
        ///// <summary>
        ///// 排序
        ///// </summary>
        ///// <param name="updateSortDtos"></param>
        ///// <returns></returns>
        //public async Task<bool> UpdateSortBomTechnologyAction(List<UpdateSortDto> updateSortDtos)
        //{
        //    try
        //    {
        //        var ids = updateSortDtos.Select(p => p.id).ToArray();
        //        var list = _db.Queryable<BPA_BomTechnologyAction>().Where(x => ids.Contains(x.Id)).ToList();
        //        list.ForEach(x => x.Sort = updateSortDtos.Where(p => p.id == x.Id).FirstOrDefault().sort);
        //        return await _db.Updateable(list).ExecuteCommandAsync() > 0;
        //    }
        //    catch (Exception e)
        //    {
        //        throw Oops.Oh("更新出错");
        //    }
        //}
        //#endregion
        #region 商品工艺（新版本工艺制作）
        /// <summary>
        /// 添加商品工艺
        /// </summary>
        /// <param name="inputDto"></param>
        /// <returns></returns>
        public async Task<bool> UpdateGoodsTechnologyAction(List<GoodsTechnologyActionBaseDto> inputDto)
        {
            try
            {
                var addlist = new List<BPA_GoodsTechnologyAction>();
                var list = _db.Queryable<BPA_GoodsTechnologyAction>().Where(x => x.DeviceId == inputDto[0].DeviceId && x.GoodsId == inputDto[0].GoodsId).ToList();
                _db.Ado.BeginTran();
                _db.Deleteable(list).ExecuteCommand();
                //var list = _db.Queryable<BPA_GoodsTechnologyAction>().Where(x => x.GroupId == groupId && x.IsDeleted == 0).ToList();

                for (int i = 0; i < inputDto.Count; i++)
                {
                    var goodsinfo = _db.Queryable<BPA_GoodsInfo>().Where(x => x.Id == inputDto[i].GoodsId).First();
                    var maxsort = _db.Queryable<BPA_GoodsTechnologyAction>().Where(x => x.GoodsId == inputDto[i].GoodsId && x.DeviceId == inputDto[i].DeviceId).Max(x => x.Sort);
                    var data = new BPA_GoodsTechnologyAction()
                    {
                        Id = string.IsNullOrEmpty(inputDto[i].Id) ? Guid.NewGuid().ToString() : inputDto[i].Id,
                        GoodsId = inputDto[i].GoodsId,
                        ActionJson = inputDto[i].ActionJson,
                        StepName = inputDto[i].StepName,
                        ChnologyId = inputDto[i].ChnologyId,
                        CreateAt = DateTime.Now,
                        IsDeleted = 0,
                        GoodsAttributeId = inputDto[i].GoodsAttributeId,
                        Sort = string.IsNullOrWhiteSpace(inputDto[i].Sort.ToString()) ? maxsort + (i + 1) : Convert.ToInt32(inputDto[i].Sort.ToString()),
                        IsBatch = inputDto[i].IsBatch,
                        DeviceId = inputDto[i].DeviceId,
                    };
                    if (!goodsinfo.IsAttrubute)
                    {
                        var sx = _db.Queryable<BPA_GoodsAttributeValue, BPA_GoodsAttribute>((a, b) => new JoinQueryInfos(
                     JoinType.Left, a.GoodsAttributeId == b.Id)).Where((a, b) => b.AttributeName == "默认属性").Select((a, b) => new BPA_GoodsAttributeValue() { Id = a.Id.SelectAll() }).First();
                        data.GoodsAttributeId = sx?.Id;
                    }
                    addlist.Add(data);
                }
                var res = await _db.Insertable(addlist).CallEntityMethod(m => m.Create()).ExecuteCommandAsync();
                _db.Ado.CommitTran();
                return res > 0;
            }
            catch (Exception e)
            {
                _db.Ado.RollbackTran();
                throw Oops.Oh("保存失败");
            }

        }
        public async Task<bool> AddGoodsTechnologyAction(List<GoodsTechnologyActionBaseDto> inputDto)
        {
            try
            {
                var addlist = new List<BPA_GoodsTechnologyAction>();
                for (int i = 0; i < inputDto.Count; i++)
                {
                    var goodsinfo = _db.Queryable<BPA_GoodsInfo>().Where(x => x.Id == inputDto[i].GoodsId).First();
                    var maxsort = _db.Queryable<BPA_GoodsTechnologyAction>().Where(x => x.GoodsId == inputDto[i].GoodsId && x.DeviceId == inputDto[i].DeviceId).Max(x => x.Sort);
                    var data = new BPA_GoodsTechnologyAction()
                    {
                        Id = string.IsNullOrEmpty(inputDto[i].Id) ? Guid.NewGuid().ToString() : inputDto[i].Id,
                        GoodsId = inputDto[i].GoodsId,
                        ActionJson = inputDto[i].ActionJson,
                        StepName = inputDto[i].StepName,
                        ChnologyId = inputDto[i].ChnologyId,
                        CreateAt = DateTime.Now,
                        IsDeleted = 0,
                        GoodsAttributeId = inputDto[i].GoodsAttributeId,
                        Sort = string.IsNullOrWhiteSpace(inputDto[i].Sort.ToString()) ? maxsort + (i + 1) : Convert.ToInt32(inputDto[i].Sort.ToString()),
                        IsBatch = inputDto[i].IsBatch,
                        DeviceId = inputDto[i].DeviceId,
                    };
                    if (!goodsinfo.IsAttrubute)
                    {
                        var sx = _db.Queryable<BPA_GoodsAttributeValue, BPA_GoodsAttribute>((a, b) => new JoinQueryInfos(
                     JoinType.Left, a.GoodsAttributeId == b.Id)).Where((a, b) => b.AttributeName == "默认属性").Select((a, b) => new BPA_GoodsAttributeValue() { Id = a.Id.SelectAll() }).First();
                        data.GoodsAttributeId = sx?.Id;
                    }
                    addlist.Add(data);
                }
                var res = await _db.Insertable(addlist).CallEntityMethod(m => m.Create()).ExecuteCommandAsync();
                return res > 0;
            }
            catch (Exception e)
            {
                throw Oops.Oh("保存失败");
            }

        }
        public async Task<List<GoodsTechnologyActionListView>> GetGoodsTechnologyAction(string goodsId)
        {
            List<GoodsTechnologyActionListView> goodsTechnologyActionListViews = new List<GoodsTechnologyActionListView>();
            var list = _db.Queryable<BPA_GoodsTechnologyAction>().Where(x =>  x.GoodsId == goodsId)
                .Select(x => new GoodsTechnologyActionView()
                {
                    Id = x.Id.SelectAll(),
                }).OrderBy(x => x.Sort, OrderByType.Asc).ToList();
            var Devicelist = await _db.Queryable<BPA_DeviceInfo>().ToListAsync();
            var s = list.GroupBy(x => x.DeviceId).ToList();
            for (int i = 0; i < s.Count; i++)
            {
                GoodsTechnologyActionListView item = new()
                {
                    DeviceId = s[i].Key,
                    DeviceName = Devicelist?.FirstOrDefault(x => x.Id == s[i].Key).DeviceName,
                    Data = s[i].AsQueryable().ToList(),
                };
                goodsTechnologyActionListViews.Add(item);
            }
            return goodsTechnologyActionListViews;
        }
        public async Task<bool> DeleteGoodsTechnologyAction(string id)
        {
            var item = await _db.Queryable<BPA_GoodsTechnologyAction>().Where(x => x.Id == id).FirstAsync();
            if (item != null)
            {
                var res = await _db.Deleteable(item).ExecuteCommandAsync() > 0;
                var list = _db.Queryable<BPA_GoodsTechnologyAction>().Where(x =>x.GoodsId == item.GoodsId && x.DeviceId == item.DeviceId).OrderBy(x => x.Sort, OrderByType.Asc).ToList();
                var uplist = new List<BPA_GoodsTechnologyAction>();
                for (int i = 0; i < list.Count; i++)
                {
                    list[i].Sort = i + 1;
                    uplist.Add(list[i]);
                }
                if (uplist.Count > 0)
                {
                    await _db.Updateable(uplist).ExecuteCommandAsync();
                }
                return true;
            }
            else
            {
                throw Oops.Oh("找不到相关数据，删除失败");
            }
        }
        public async Task<bool> DeleteGoodsTechnologyAction(GoodsTechnologDelete dto)
        {
            var item = await _db.Queryable<BPA_GoodsTechnologyAction>().Where(x => x.DeviceId == dto.devideId && x.GoodsId == dto.goodsId).ToListAsync();
            if (item.Count > 0)
            {
                return await _db.Deleteable(item).ExecuteCommandAsync() > 0;
            }
            else
            {
                throw Oops.Oh("找不到相关数据，删除失败");
            }
        }
        public async Task<List<DeviceGoodsTechnologyView>> GetDeviceTechnology()
        {
            var list = await _db.Queryable<BPA_DeviceInfo>().Select(x => new DeviceGoodsTechnologyView()
            {
                Id = x.Id.SelectAll(),
            }).Mapper(a =>
            {
                a.GoodsTechnologyInfo = _db.Queryable<BPA_DeviceTechnology>().Where(d => d.DeviceVersionKey == a.DeviceVersionKey).Select(d => new GoodsTechnologyInfo()
                {
                    DeviceTechnologyId = d.Id,
                    DeviceVersionKey = d.DeviceVersionKey,
                    Name = d.Name,
                }).ToList();
            }).ToListAsync();
            return list;
        }
        #endregion
        
    }
}
