﻿using BPA.SAAS.Manage.Application.Device.Dtos.DeviceTechnology;
using BPA.SAAS.Manage.Core.Base;
using BPA.SAAS.Manage.Core.Device;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPA.SAAS.Manage.Application.Device.Interface
{
    public interface IDeviceTechnologyService
    {
        /// <summary>
        /// 获取工艺基础信息列表
        /// </summary>
        /// <param name="inputDto"></param>
        /// <returns></returns>
       Task<PageUtil> GetDeviceTechnologyPage(DeviceTechnologyPageBase inputDto);
        /// <summary>
        /// 查询所有工艺信息
        /// </summary>
        /// <returns></returns>
        Task<List<DeviceTechnologyDto>> GetDeviceTechnology();
        /// <summary>
        /// 添加工艺
        /// </summary>
        /// <param name="inputDto"></param>
        /// <returns></returns>
       Task<bool> AddDeviceTechnology(DeviceTechnologyBaseDto inputDto);
        /// <summary>
        /// 修改工艺
        /// </summary>
        /// <param name="inputDto"></param>
        /// <returns></returns>
        Task<bool> UpdateDeviceTechnology(DeviceTechnologyBaseDto inputDto);
        /// <summary>
        /// 删除工艺
        /// </summary>
        /// <param name="ids"></param>
        /// <returns></returns>
        Task<bool> DeleteDeviceTechnology(List<string> ids);
        /// <summary>
        /// 根据工艺id查询工艺模型
        /// </summary>
        /// <returns></returns>
        Task<List<BPA_DeviceTechnologyAction>> GetTechnologyActionList(string devicetechnologyId);
        /// <summary>
        /// 查询所有工艺模型
        /// </summary>
        /// <returns></returns>
        Task<List<BPA_DeviceTechnologyAction>> GetTechnologyActionList();
        /// <summary>
        /// 添加工艺模型
        /// </summary>
        /// <param name="inputDto"></param>
        /// <returns></returns>
        Task<bool> AddDeviceTechnologyAction(DeviceTechnologyActionBaseDto inputDto);
        /// <summary>
        /// 修改工艺模型
        /// </summary>
        /// <param name="inputDto"></param>
        /// <returns></returns>
        Task<bool> UpdateBomTechnology(DeviceTechnologyActionBaseDto inputDto);
        /// <summary>
        /// 删除工艺模型
        /// </summary>
        /// <param name="ids"></param>
        /// <returns></returns>
        Task<bool> DeleteTechnologyAction(List<string> ids);
    }
}
