﻿using BPA.SAAS.Manage.Core.Base;
using SqlSugar;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Principal;
using System.Text;
using System.Threading.Tasks;

namespace BPA.SAAS.Manage.Core.Device
{
    [SugarTable("bpa_deviceinfo")]
    public class BPA_DeviceInfo: IBaseEntity, IGroupId
    {

        /// <summary> 
        ///  设备名称
        /// </summary> 
        public string DeviceName { get; set; }

        /// <summary> 
        ///  设备标签
        /// </summary> 
        public string DeviceTypeId { get; set; }
        /// <summary>
        ///归属场景（店铺）
        /// </summary>
        public string OrgId { get; set; }
        /// <summary>
        /// 设备类型
        /// </summary>
        public string DeviceTypeKey { get; set; }
        /// <summary>
        /// 设备AutoKey 唯一用于mqtt消息推送标识
        /// </summary>
        [SugarColumn(IsOnlyIgnoreInsert = true, IsOnlyIgnoreUpdate = true, IsIdentity = true)]
        public int AutoKey { get; set; }
        /// <summary>
        /// 物料数量
        /// </summary>
        public int? MaterialQuantity { get; set; }
        /// <summary>
        /// 设备版本
        /// </summary>
        public string DeviceVersionKey { get; set; }
        public string GroupId { get; set; }
    }
}
